<div class="row mb-3 align-items-center justify-content-between">
  <div class="col-md-auto col-sm-auto">
    <div class="section-title">
      <h2 >{{'DOCUMENT_CATEGORIES' | translate}}</h2>
    </div>
  </div>
  <!-- <div class="col-md-auto col-sm-auto">
    <h4 class="widget-title">
      <button *hasClaim="'document_category_create_category'" class="btn btn-success btn-sm m-right-10" (click)="manageCategory({})">
        <i class="las la-plus"></i>
        {{'ADD_DOCUMENT_CATEGORY' | translate}}
      </button>
    </h4>
  </div> -->
</div>

<div class="mat-elevation-z8">
  <div class="table-container">
    <!-- Parent -->
    <table mat-table [dataSource]="categories" multiTemplateDataRows class="mat-elevation-z8 table">
      <ng-container matColumnDef="subcategory">
        <th style="width:7%" mat-header-cell *matHeaderCellDef> </th>
        <td style="width:7%" mat-cell *matCellDef="let element">
          <i class="las la-angle-double-right btn" *ngIf="!expandedElement1 || (expandedElement1 && (element.id != expandedElement1.id))" (click)="toggleRow(element)"></i>
          <i class="las la-angle-double-down btn" *ngIf="expandedElement1 && (element.id == expandedElement1.id)" (click)="toggleRow(element)"></i>
        </td>
      </ng-container>
      <ng-container matColumnDef="action">
        <th style="width:10%" mat-header-cell *matHeaderCellDef>{{'ACTION' | translate}} </th>
        <td style="width:10%" mat-cell *matCellDef="let element">
          <button *hasClaim="'document_category_edit_category'" (click)="manageCategory(element)"
            class="btn btn-success btn-sm m-right-10" type="button">
            <i class="las la-pen"></i>
            {{'EDIT' | translate}}
          </button>
          <!-- <button *hasClaim="'document_category_delete_category'" (click)="deleteCategory(element)" class="btn btn-danger btn-sm"
            type="button">
            <i class="las la-trash"></i>
            {{'DELETE' | translate}}
          </button> -->
        </td>
      </ng-container>
      <ng-container matColumnDef="name">
        <th mat-header-cell *matHeaderCellDef> {{'NAME' | translate}} </th>
        <td mat-cell *matCellDef="let element"> {{element.name}} </td>
      </ng-container>
      <!-- Child 1 -->
      <ng-container matColumnDef="expandedDetail1">
        <td mat-cell *matCellDef="let categoryObject" [attr.colspan]="columnsToDisplay.length">
          <div class="example-element-detail" [@detailExpand]="expandedElement1 && (categoryObject.id == expandedElement1.id) ? 'expanded' : 'collapsed'">
            <div class="inner-table mat-elevation-z8">
              <div class="row mb-3 align-items-center justify-content-between">
                <div class="col-md-auto col-sm-auto">
                  <div class="section-title">
                    <h2>{{'CHILD_CATEGORIES' | translate}}: {{categoryObject.name}}</h2>
                  </div>
                </div>
                <div class="col-md-auto col-sm-auto">
                  <h4 class="widget-title">
                    <button *hasClaim="'document_category_create_category'" class="btn btn-success btn-sm m-right-10"
                      (click)="addSubCategory(categoryObject)">
                      <i class="las la-plus"></i>
                      {{'ADD_CHILD_CATEGORY' | translate}}
                    </button>
                  </h4>
                </div>
              </div>
              <table mat-table [dataSource]="subCategories1" multiTemplateDataRows class="table">
                <ng-container matColumnDef="subcategory">
                  <th style="width:7%" mat-header-cell *matHeaderCellDef> </th>
                  <td style="width:7%" mat-cell *matCellDef="let element">
                    <i class="las la-angle-double-right btn" *ngIf="!expandedElement2 || (expandedElement2 && (element.id != expandedElement2.id))" (click)="toggleRow2(element)"></i>
                    <i class="las la-angle-double-down btn" *ngIf="expandedElement2 && (element.id == expandedElement2.id)" (click)="toggleRow2(element)"></i>
                  </td>
                </ng-container>
                <ng-container matColumnDef="action">
                  <th style="width:17%" mat-header-cell *matHeaderCellDef>{{'ACTION' | translate}} </th>
                  <td style="width:17%" mat-cell *matCellDef="let element">
                    <button *hasClaim="'document_category_edit_category'" (click)="manageCategory(element)"
                      class="btn btn-success btn-sm m-right-10" type="button">
                      <i class="las la-pen"></i>
                      {{'EDIT' | translate}}
                    </button>
                    <button *hasClaim="'document_category_delete_category'" (click)="deleteCategory(element)"
                      class="btn btn-danger btn-sm" type="button">
                      <i class="las la-trash"></i>
                      {{'DELETE' | translate}}
                    </button>
                  </td>
                </ng-container>
                <ng-container matColumnDef="name">
                  <th mat-header-cell *matHeaderCellDef> {{'NAME' | translate}} </th>
                  <td mat-cell *matCellDef="let element"> {{element.name}} </td>
                </ng-container>
                <!-- Child 2 -->
                <ng-container matColumnDef="expandedDetail2">
                  <td mat-cell *matCellDef="let categoryObject" [attr.colspan]="subCategoryColumnToDisplay.length">
                    <div class="example-element-detail" [@detailExpand]="expandedElement2 && (categoryObject.id == expandedElement2.id) ? 'expanded' : 'collapsed'">
                      <div class="inner-table mat-elevation-z8">
                        <div class="row mb-3 align-items-center justify-content-between">
                          <div class="col-md-auto col-sm-auto">
                            <div class="section-title">
                              <h2>{{'CHILD_CATEGORIES' | translate}}: {{categoryObject.name}}</h2>
                            </div>
                          </div>
                          <div class="col-md-auto col-sm-auto">
                            <h4 class="widget-title">
                              <button *hasClaim="'document_category_create_category'" class="btn btn-success btn-sm m-right-10"
                                (click)="addSubCategory(categoryObject)">
                                <i class="las la-plus"></i>
                                {{'ADD_CHILD_CATEGORY' | translate}}
                              </button>
                            </h4>
                          </div>
                        </div>
                        <table mat-table [dataSource]="subCategories2" multiTemplateDataRows class="table">
                          <ng-container matColumnDef="subcategory">
                            <th style="width:7%" mat-header-cell *matHeaderCellDef> </th>
                            <td style="width:7%" mat-cell *matCellDef="let element">
                              <i class="las la-angle-double-right btn" *ngIf="!expandedElement3 || (expandedElement3 && (element.id != expandedElement3.id))" (click)="toggleRow3(element)"></i>
                              <i class="las la-angle-double-down btn" *ngIf="expandedElement3 && (element.id == expandedElement3.id)" (click)="toggleRow3(element)"></i>
                            </td>
                          </ng-container>
                          <ng-container matColumnDef="action">
                            <th style="width:22%" mat-header-cell *matHeaderCellDef>{{'ACTION' | translate}} </th>
                            <td style="width:22%" mat-cell *matCellDef="let element">
                              <button *hasClaim="'document_category_edit_category'" (click)="manageCategory(element)"
                                class="btn btn-success btn-sm m-right-10" type="button">
                                <i class="las la-pen"></i>
                                {{'EDIT' | translate}}
                              </button>
                              <button *hasClaim="'document_category_delete_category'" (click)="deleteCategory(element)"
                                class="btn btn-danger btn-sm" type="button">
                                <i class="las la-trash"></i>
                                {{'DELETE' | translate}}
                              </button>
                            </td>
                          </ng-container>
                          <ng-container matColumnDef="name">
                            <th mat-header-cell *matHeaderCellDef> {{'NAME' | translate}} </th>
                            <td mat-cell *matCellDef="let element"> {{element.name}} </td>
                          </ng-container>
                          <!-- Child 3 -->
                          <ng-container matColumnDef="expandedDetail3">
                            <td mat-cell *matCellDef="let categoryObject" [attr.colspan]="subCategoryColumnToDisplay.length">
                              <div class="example-element-detail" [@detailExpand]="expandedElement3 && (categoryObject.id == expandedElement3.id) ? 'expanded' : 'collapsed'">
                                <div class="inner-table mat-elevation-z8">
                                  <div class="row mb-3 align-items-center justify-content-between">
                                    <div class="col-md-auto col-sm-auto">
                                      <div class="section-title">
                                        <h2>{{'CHILD_CATEGORIES' | translate}}: {{categoryObject.name}}</h2>
                                      </div>
                                    </div>
                                    <div class="col-md-auto col-sm-auto">
                                      <h4 class="widget-title">
                                        <button *hasClaim="'document_category_create_category'" class="btn btn-success btn-sm m-right-10"
                                          (click)="addSubCategory(categoryObject)">
                                          <i class="las la-plus"></i>
                                          {{'ADD_CHILD_CATEGORY' | translate}}
                                        </button>
                                      </h4>
                                    </div>
                                  </div>
                                  <table mat-table [dataSource]="subCategories3" multiTemplateDataRows class="table">
                                    <ng-container matColumnDef="action">
                                      <th style="width:32%" mat-header-cell *matHeaderCellDef>{{'ACTION' | translate}} </th>
                                      <td style="width:32%" mat-cell *matCellDef="let element">
                                        <button *hasClaim="'document_category_edit_category'" (click)="manageCategory(element)"
                                          class="btn btn-success btn-sm m-right-10" type="button">
                                          <i class="las la-pen"></i>
                                          {{'EDIT' | translate}}
                                        </button>
                                        <button *hasClaim="'document_category_delete_category'" (click)="deleteCategory(element)"
                                          class="btn btn-danger btn-sm" type="button">
                                          <i class="las la-trash"></i>
                                          {{'DELETE' | translate}}
                                        </button>
                                      </td>
                                    </ng-container>
                                    <ng-container matColumnDef="name">
                                      <th mat-header-cell *matHeaderCellDef> {{'NAME' | translate}} </th>
                                      <td mat-cell *matCellDef="let element"> {{element.name}} </td>
                                    </ng-container>

                                    <tr mat-header-row *matHeaderRowDef="subCategoryColumnToDisplay3;sticky: true"></tr>
                                    <tr mat-row *matRowDef="let row; columns: subCategoryColumnToDisplay3;"></tr>
                                  </table>
                                </div>
                              </div>
                            </td>
                          </ng-container>

                          <tr mat-header-row *matHeaderRowDef="subCategoryColumnToDisplay2;sticky: true"></tr>
                          <tr mat-row *matRowDef="let row; columns: subCategoryColumnToDisplay2;"></tr>
                          <tr mat-row *matRowDef="let row; columns: ['expandedDetail3']" class="example-detail-row"></tr>
                        </table>
                      </div>
                    </div>
                  </td>
                </ng-container>

                <tr mat-header-row *matHeaderRowDef="subCategoryColumnToDisplay;sticky: true"></tr>
                <tr mat-row *matRowDef="let row; columns: subCategoryColumnToDisplay;"></tr>
                <tr mat-row *matRowDef="let row; columns: ['expandedDetail2']" class="example-detail-row"></tr>
              </table>
            </div>
          </div>
        </td>
      </ng-container>

      <tr mat-header-row *matHeaderRowDef="columnsToDisplay;sticky: true"></tr>
      <tr mat-row *matRowDef="let row; columns: columnsToDisplay;"></tr>
      <tr mat-row *matRowDef="let row; columns: ['expandedDetail1']" class="example-detail-row"></tr>
    </table>
  </div>
</div>
